/* Sistemas Integrados TEKNISA

Nome: 5101_DFSSTPS_BASECALC_RETIDO.SQL

Descrio:
PROCEDIMENTO PARA ATUALIZAO DOS IMPOSTOS, MENSAGENS E
VALOR DA NOTA FISCAL.

SET @V_DEBUGA = CONVERT(VARCHAR, @V_VRBCPERIODO)

      RAISERROR(@V_DEBUGA, 16,1);

     DECLARE @V_DEBUGA VARCHAR(50);

Criao:
03/10/2005 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'BASECALC_RETIDO'  and
            type   = 'P'                and
            u.uid  = o.uid              and
            u.name = USER)
  DROP PROCEDURE BASECALC_RETIDO
  GO

CREATE PROCEDURE BASECALC_RETIDO
   @P_IDRECALCULO   VARCHAR(01),
   @P_CDFILIAL      VARCHAR(04),
   @P_NRLANCTONF    VARCHAR(10),
   @P_IDTPIJURNF    VARCHAR(01),
   @P_NRINSJURNF    VARCHAR(20),
   @P_DATALANCNF    DATETIME,
   @P_CDIMPOSTO     VARCHAR(02),
   @P_IDENTRSAIDOP  VARCHAR(01),
   @P_CDEMPRESA     VARCHAR(02),
   @P_INSCESTA      VARCHAR(16) = NULL,
   @P_PAISORIG      VARCHAR(04) = NULL,
   @P_ESTAORIG      VARCHAR(02) = NULL,
   @P_PAISDEST      VARCHAR(04) = NULL,
   @P_ESTADEST      VARCHAR(02) = NULL,
   @P_CDGRUPOFISC   VARCHAR(03) = NULL,
   @P_CDGRPFISCSV   VARCHAR(03) = NULL,
   @P_TIPOOPER      VARCHAR(02) = NULL
AS

   DECLARE @V_VRBCPERIODO   DOUBLE PRECISION;
   DECLARE @V_VRBASECALNF   DOUBLE PRECISION;
   DECLARE @V_VRMINBASE     DOUBLE PRECISION;
   DECLARE @V_VRIMPOSTO     DOUBLE PRECISION;
   DECLARE @V_VRALIQUOTA    DOUBLE PRECISION;
   DECLARE @V_NRDECITOTANF  DOUBLE PRECISION;
   DECLARE @V_VRDIFERENCA   DOUBLE PRECISION;
   DECLARE @V_VRTOTIMPONF   DOUBLE PRECISION;
   DECLARE @V_VRIMPOSTOIT   DOUBLE PRECISION;
   DECLARE @V_VRBCALCIMPOIT DOUBLE PRECISION;
   DECLARE @V_DATAINI       DATETIME;
   DECLARE @V_IDFORMAPUR    VARCHAR(01);
   DECLARE @V_DTATUAPAG     DATETIME;
   DECLARE @V_DTULTMES      DATETIME;
   DECLARE @V_BASECALCNF    DOUBLE PRECISION;
   DECLARE @V_ITEM_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ITEM_VRBCALCIRRF  DOUBLE PRECISION;
   DECLARE @V_NRSEQUNOTAIT      VARCHAR(04);
   DECLARE @V_NRSEQAUX          VARCHAR(04);
   DECLARE @V_NOTABCMENSAL_CDFILIAL   VARCHAR(04);
   DECLARE @V_NOTABCMENSAL_NRLANCTONF VARCHAR(10);
   DECLARE @V_UTBCMENS      VARCHAR(01);
   DECLARE @V_UTFXVAL       VARCHAR(01);
   DECLARE @V_CALCIMPRET    VARCHAR(01);
   DECLARE @V_IMPOSTODESC   DOUBLE PRECISION;
   DECLARE @V_BASECALCDESC  DOUBLE PRECISION;
   DECLARE @V_PARDEDTMP     DOUBLE PRECISION;
   DECLARE @V_CDARVPROD     VARCHAR(20);
   DECLARE @V_FATOCONV      DOUBLE PRECISION;
   DECLARE @V_VRITEMALIQ    DOUBLE PRECISION;
   DECLARE @V_VRMAXIMP      DOUBLE PRECISION;   

BEGIN
   SET @V_VRMINBASE    = 0;
   SET @V_VRBCPERIODO  = 0;
   SET @V_VRBASECALNF  = 0;
   SET @V_VRALIQUOTA   = 0;

   IF @P_IDRECALCULO = 'S' BEGIN

      SET @V_UTBCMENS   = 'N';
      SET @V_UTFXVAL    = 'N';
      SET @V_CALCIMPRET = 'N';

      SELECT @V_UTBCMENS = ISNULL(IDUTVRMENSBC, 'N'),
             @V_UTFXVAL  = ISNULL(IDUTFAIXVLR, 'N')
        FROM IMPOSTO
       WHERE CDIMPOSTO = @P_CDIMPOSTO;

      SELECT @V_NRDECITOTANF = ISNULL(MAX(NRDECITOTANF),2)
        FROM  PARAMGERAL;

      SELECT @V_VRMINBASE  = MAX(VRMINBASECAL),
             @V_IDFORMAPUR = ISNULL(MAX(IDFORMAPUR), 'C'),
             @V_VRMAXIMP   = ISNULL(MAX(VRMAXIMP), 0)
      FROM IMPOSTO
      WHERE CDIMPOSTO = @P_CDIMPOSTO;

      SET @V_DATAINI = CONVERT(DATETIME,('01/'+SUBSTRING(CONVERT(VARCHAR, @P_DATALANCNF, 103),4,7)),103);

      IF @V_IDFORMAPUR = 'P' BEGIN

         IF @P_IDENTRSAIDOP = 'E' BEGIN

            SELECT @V_DTATUAPAG = MIN(DTORIGVENPAG)
              FROM CONTAPAGAR
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANCTONF = @P_NRLANCTONF;

            IF (@V_DTATUAPAG IS NULL) OR (@V_DTATUAPAG = 0) BEGIN
               SET @V_DTATUAPAG = @V_DATAINI;
            END
            ELSE BEGIN
               SET @V_DTATUAPAG = CONVERT(DATETIME,('01/'+SUBSTRING(CONVERT(VARCHAR, @V_DTATUAPAG, 103),4,7)),103);
            END;

            SET @V_DTULTMES = DATEADD(MM,1,@V_DTATUAPAG)-DAY(@V_DTATUAPAG);

            IF  (@V_UTBCMENS = 'S' AND @V_UTFXVAL = 'S') BEGIN /* Se utiliza base de clculo mensal e faixa de valores */
               SELECT @V_VRBCPERIODO = SUM(VRBCALCIRRF)
                 FROM NOTAFISCAL NF, ITEMPROIMPOS IP
                WHERE NF.CDEMPRESA    = @P_CDEMPRESA                         AND
                      NF.IDTPIJURNF   = @P_IDTPIJURNF                        AND
                      ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                        OR NF.NRINSJURNF = @P_NRINSJURNF)                    AND
                      NF.IDENTRSAIDOP = @P_IDENTRSAIDOP                      AND
                      NF.CDFILIAL     = IP.CDFILIAL                          AND
                      NF.NRLANCTONF   = IP.NRLANCTONF                        AND
                      IP.CDIMPOSTO    = @P_CDIMPOSTO                         AND
                      NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF AND
                      IP.VRBCALCIRRF > 0                                    AND
                      EXISTS (SELECT C.CDFILIAL
                                FROM CONTAPAGAR C
                               WHERE C.CDFILIAL = NF.CDFILIAL
                                 AND C.NRLANCTONF = NF.NRLANCTONF
                                 AND DTORIGVENPAG BETWEEN @V_DTATUAPAG AND @V_DTULTMES);


               SELECT @V_BASECALCNF = SUM(VRBCALCIRRF)
                 FROM ITEMPROIMPOS IP
                WHERE IP.CDFILIAL     = @P_CDFILIAL
                  AND IP.NRLANCTONF   = @P_NRLANCTONF
                  AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                  AND IP.VRBCALCIRRF > 0;

               SET @V_CALCIMPRET = 'S';

            END
            ELSE BEGIN
               SELECT @V_VRBCPERIODO = SUM(VRBASECALCNF)
                 FROM NOTAFISCAL NF, IMPOSTONF IP
                WHERE NF.CDEMPRESA    = @P_CDEMPRESA                         AND
                      NF.IDTPIJURNF   = @P_IDTPIJURNF                        AND
                      ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                        OR NF.NRINSJURNF = @P_NRINSJURNF)                    AND
                      NF.IDENTRSAIDOP = @P_IDENTRSAIDOP                      AND
                      NF.CDFILIAL     = IP.CDFILIAL                          AND
                      NF.NRLANCTONF   = IP.NRLANCTONF                        AND
                      IP.CDIMPOSTO    = @P_CDIMPOSTO                         AND
                      NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF AND
                      IP.VRBASECALCNF > 0                                    AND
                      EXISTS (SELECT C.CDFILIAL
                                FROM CONTAPAGAR C
                               WHERE C.CDFILIAL = NF.CDFILIAL
                                 AND C.NRLANCTONF = NF.NRLANCTONF
                                 AND DTORIGVENPAG BETWEEN @V_DTATUAPAG AND @V_DTULTMES);


               SELECT @V_BASECALCNF = SUM(VRBASECALCNF)
                 FROM IMPOSTONF IP
                WHERE IP.CDFILIAL     = @P_CDFILIAL
                  AND IP.NRLANCTONF   = @P_NRLANCTONF
                  AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                  AND IP.VRBASECALCNF > 0;
            END;

            SET @V_VRBCPERIODO = ISNULL(@V_VRBCPERIODO,0) + ISNULL(@V_BASECALCNF,0);
         END
         ELSE BEGIN
            SELECT @V_DTATUAPAG = MIN(DTATUAVENREC)
              FROM CONTARECEBER
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANCTONF = @P_NRLANCTONF;

            IF (@V_DTATUAPAG IS NULL) OR (@V_DTATUAPAG = 0) BEGIN
               SET @V_DTATUAPAG = @V_DATAINI;
            END
            ELSE BEGIN
               SET @V_DTATUAPAG = CONVERT(DATETIME,('01/'+SUBSTRING(CONVERT(VARCHAR, @V_DTATUAPAG, 103),4,7)),103);
            END;

            SET @V_DTULTMES = DATEADD(MM,1,@V_DTATUAPAG)-DAY(@V_DTATUAPAG);

            IF  (@V_UTBCMENS = 'S' AND @V_UTFXVAL = 'S') BEGIN /* Se utiliza base de clculo mensal e faixa de valores */
               SELECT @V_VRBCPERIODO = SUM(VRBCALCIRRF)
                 FROM NOTAFISCAL NF, ITEMPROIMPOS IP
                WHERE NF.CDEMPRESA    = @P_CDEMPRESA                         AND
                      NF.IDTPIJURNF   = @P_IDTPIJURNF                        AND
                      ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                        OR NF.NRINSJURNF = @P_NRINSJURNF)                    AND
                      NF.IDENTRSAIDOP = @P_IDENTRSAIDOP                      AND
                      NF.CDFILIAL     = IP.CDFILIAL                          AND
                      NF.NRLANCTONF   = IP.NRLANCTONF                        AND
                      IP.CDIMPOSTO    = @P_CDIMPOSTO                         AND
                      NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF AND
                      IP.VRBCALCIRRF > 0                                    AND
                      EXISTS (SELECT C.CDFILIAL
                                FROM CONTARECEBER C
                               WHERE C.CDFILIAL = NF.CDFILIAL
                                 AND C.NRLANCTONF = NF.NRLANCTONF
                                 AND DTATUAVENREC BETWEEN @V_DTATUAPAG AND @V_DTULTMES);


               SELECT @V_BASECALCNF = SUM(VRBCALCIRRF)
                 FROM ITEMPROIMPOS IP
                WHERE IP.CDFILIAL     = @P_CDFILIAL
                  AND IP.NRLANCTONF   = @P_NRLANCTONF
                  AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                  AND IP.VRBCALCIRRF > 0;

               SET @V_CALCIMPRET = 'S';
            END
            ELSE BEGIN
               SELECT @V_VRBCPERIODO = SUM(VRBASECALCNF)
                 FROM NOTAFISCAL NF, IMPOSTONF IP
                WHERE NF.CDEMPRESA    = @P_CDEMPRESA                         AND
                      NF.IDTPIJURNF   = @P_IDTPIJURNF                        AND
                      ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                        OR NF.NRINSJURNF = @P_NRINSJURNF)                    AND
                      NF.IDENTRSAIDOP = @P_IDENTRSAIDOP                      AND
                      NF.CDFILIAL     = IP.CDFILIAL                          AND
                      NF.NRLANCTONF   = IP.NRLANCTONF                        AND
                      IP.CDIMPOSTO    = @P_CDIMPOSTO                         AND
                      NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF AND
                      IP.VRBASECALCNF > 0                                    AND
                      EXISTS (SELECT C.CDFILIAL
                                FROM CONTARECEBER C
                               WHERE C.CDFILIAL = NF.CDFILIAL
                                 AND C.NRLANCTONF = NF.NRLANCTONF
                                 AND DTATUAVENREC BETWEEN @V_DTATUAPAG AND @V_DTULTMES);


               SELECT @V_BASECALCNF = SUM(VRBASECALCNF)
                 FROM IMPOSTONF IP
                WHERE IP.CDFILIAL     = @P_CDFILIAL
                  AND IP.NRLANCTONF   = @P_NRLANCTONF
                  AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                  AND IP.VRBASECALCNF > 0;

            END;

            SET @V_VRBCPERIODO = ISNULL(@V_VRBCPERIODO,0) + ISNULL(@V_BASECALCNF,0);
         END;
      END
      ELSE BEGIN
         IF  (@V_UTBCMENS = 'S' AND @V_UTFXVAL = 'S') BEGIN /* Se utiliza base de clculo mensal e faixa de valores */
            SELECT @V_VRBCPERIODO = SUM(VRBCALCIRRF)
              FROM NOTAFISCAL NF, ITEMPROIMPOS IP
             WHERE NF.CDEMPRESA    = @P_CDEMPRESA    AND
                   NF.IDTPIJURNF   = @P_IDTPIJURNF   AND
                   ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                     OR NF.NRINSJURNF = @P_NRINSJURNF)AND
                   NF.IDENTRSAIDOP = @P_IDENTRSAIDOP AND
                   NF.DTENTRSAID  BETWEEN @V_DATAINI AND @P_DATALANCNF AND
                   NF.CDFILIAL     = IP.CDFILIAL     AND
                   NF.NRLANCTONF   = IP.NRLANCTONF   AND
                   IP.CDIMPOSTO    = @P_CDIMPOSTO    AND
                   IP.VRBCALCIRRF > 0;
                   
            SET @V_CALCIMPRET = 'S';

         END
         ELSE BEGIN
            SELECT @V_VRBCPERIODO = SUM(VRBCALCIRRF)
              FROM NOTAFISCAL NF, ITEMPROIMPOS IP
             WHERE NF.CDEMPRESA    = @P_CDEMPRESA    AND
                   NF.IDTPIJURNF   = @P_IDTPIJURNF   AND
                   ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                     OR NF.NRINSJURNF = @P_NRINSJURNF)AND
                   NF.IDENTRSAIDOP = @P_IDENTRSAIDOP AND
                   NF.DTENTRSAID  BETWEEN @V_DATAINI AND @P_DATALANCNF AND
                   NF.CDFILIAL     = IP.CDFILIAL     AND
                   NF.NRLANCTONF   = IP.NRLANCTONF   AND
                   IP.CDIMPOSTO    = @P_CDIMPOSTO    AND
                   IP.VRBCALCIRRF > 0;
         END;
      END;
      IF @V_VRBCPERIODO IS NULL BEGIN
         SET @V_VRBCPERIODO = 0;
      END;

      IF (@V_CALCIMPRET = 'S') BEGIN
         SELECT @V_VRBASECALNF = SUM(VRBCALCIRRF)
           FROM ITEMPROIMPOS
          WHERE CDFILIAL   = @P_CDFILIAL
            AND NRLANCTONF = @P_NRLANCTONF
            AND CDIMPOSTO  = @P_CDIMPOSTO
            AND VRBCALCIRRF > 0;
      END
      ELSE BEGIN
         SELECT @V_VRBASECALNF = SUM(VRBASECALCNF), @V_VRALIQUOTA = MAX(VRALIQNF)
           FROM IMPOSTONF
          WHERE CDFILIAL   = @P_CDFILIAL
            AND NRLANCTONF = @P_NRLANCTONF
            AND CDIMPOSTO  = @P_CDIMPOSTO
            AND VRBASECALCNF > 0;
      END;

      SET @V_VRBCPERIODO = (@V_VRBCPERIODO - @V_VRBASECALNF);

      IF (@V_VRBCPERIODO <= @V_VRMINBASE) OR ((@V_CALCIMPRET = 'S') AND (@V_VRBCPERIODO > @V_VRMINBASE)) BEGIN

         IF ((@V_VRBASECALNF+@V_VRBCPERIODO) > @V_VRMINBASE) BEGIN

            IF (@V_CALCIMPRET = 'S') BEGIN /* Se utiliza base de clculo mensal e faixa de valores busca aliquota para a faixa do perodo*/

               DELETE FROM ALIQTEMP
                WHERE (NRALIQTEMP = @P_CDFILIAL+@P_NRLANCTONF);

               SELECT @V_CDARVPROD = MAX(CDARVPROD)
                 FROM PRODUTO P, ITEMPRODUTO IP, ITEMPROIMPOS IT
                WHERE P.CDPRODUTO    = IP.CDPRODUTO
                  AND IP.CDFILIAL    = @P_CDFILIAL
                  AND IP.NRLANCTONF  = @P_NRLANCTONF
                  AND IP.CDFILIAL    = IT.CDFILIAL
                  AND IP.NRLANCTONF  = IT.NRLANCTONF
                  AND IP.NRSEQITPROD = IT.NRSEQITPROD
                  AND IT.CDIMPOSTO   = @P_CDIMPOSTO;

               SET @V_VRITEMALIQ = @V_VRBCPERIODO + @V_VRBASECALNF;

               IF (@P_CDGRPFISCSV IS NOT NULL) BEGIN
                  EXEC CONSULTA_ALIQUOTA @P_CDIMPOSTO, @P_IDENTRSAIDOP, @P_CDEMPRESA, @V_CDARVPROD, @P_INSCESTA, @P_PAISORIG,
                                         @P_ESTAORIG, @P_PAISDEST, @P_ESTADEST, NULL, @V_VRITEMALIQ, @P_DATALANCNF, @P_CDFILIAL, @P_NRLANCTONF, @P_CDGRPFISCSV, @P_TIPOOPER,
                                         NULL, NULL, NULL, NULL, NULL, 'N';
               END
               ELSE BEGIN
                  EXEC CONSULTA_ALIQUOTA @P_CDIMPOSTO, @P_IDENTRSAIDOP, @P_CDEMPRESA, @V_CDARVPROD, @P_INSCESTA, @P_PAISORIG,
                                         @P_ESTAORIG, @P_PAISDEST, @P_ESTADEST, NULL, @V_VRITEMALIQ , @P_DATALANCNF, @P_CDFILIAL, @P_NRLANCTONF, @P_CDGRUPOFISC, @P_TIPOOPER,
                                         NULL, NULL, NULL, NULL, NULL, 'N';
               END;

               SELECT @V_VRALIQUOTA = ISNULL(MAX(VRALIQUTMP),0),
                      @V_PARDEDTMP  = ISNULL(MAX(VRPARDEDTMP),0)
                 FROM ALIQTEMP
                WHERE (NRALIQTEMP = @P_CDFILIAL+@P_NRLANCTONF);

               DELETE FROM ALIQTEMP
                WHERE (NRALIQTEMP = @P_CDFILIAL+@P_NRLANCTONF);

               IF @V_IDFORMAPUR = 'P' BEGIN
                  SELECT @V_IMPOSTODESC  = SUM(VRIMPOSTONF),
                         @V_BASECALCDESC = SUM(VRBASECALCNF)
                    FROM NOTAFISCAL NF, IMPOSTONF IP
                   WHERE NF.CDEMPRESA    = @P_CDEMPRESA                       AND
                         NF.IDTPIJURNF   = @P_IDTPIJURNF                      AND
                         ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                           OR NF.NRINSJURNF = @P_NRINSJURNF)                  AND
                         NF.IDENTRSAIDOP = @P_IDENTRSAIDOP                    AND
                         NF.CDFILIAL     = IP.CDFILIAL                        AND
                         NF.NRLANCTONF   = IP.NRLANCTONF                      AND
                         IP.CDIMPOSTO    = @P_CDIMPOSTO                       AND
                         NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF AND
                         IP.VRIMPOSTONF > 0                                   AND
                         EXISTS (SELECT C.CDFILIAL
                                   FROM CONTAPAGAR C
                                  WHERE C.CDFILIAL = NF.CDFILIAL
                                    AND C.NRLANCTONF = NF.NRLANCTONF
                                    AND DTORIGVENPAG BETWEEN @V_DTATUAPAG AND @V_DTULTMES);

               END
               ELSE BEGIN
                  SELECT @V_IMPOSTODESC  = SUM(VRIMPOSTONF),
                         @V_BASECALCDESC = SUM(VRBASECALCNF)
                    FROM NOTAFISCAL NF, IMPOSTONF IP
                   WHERE NF.CDEMPRESA    = @P_CDEMPRESA                       AND
                         NF.IDTPIJURNF   = @P_IDTPIJURNF                      AND
                         ((NF.IDTPIJURNF   = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                           OR NF.NRINSJURNF = @P_NRINSJURNF)                  AND
                         NF.IDENTRSAIDOP = @P_IDENTRSAIDOP                    AND
                         NF.CDFILIAL     = IP.CDFILIAL                        AND
                         NF.NRLANCTONF   = IP.NRLANCTONF                      AND
                         IP.CDIMPOSTO    = @P_CDIMPOSTO                       AND
                         NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF AND
                         NF.DTENTRSAID   BETWEEN @V_DATAINI AND @P_DATALANCNF AND
                         IP.VRIMPOSTONF > 0;
               END;

               SET @V_VRIMPOSTO     = ((@V_VRBCPERIODO + @V_VRBASECALNF) * (@V_VRALIQUOTA/100)) - ISNULL(@V_IMPOSTODESC, 0) - ISNULL(@V_PARDEDTMP, 0);
               SET @V_VRBCALCIMPOIT = 0;

               /* Verifica se o existe valor mximo do imposto cadastrado. Caso exista e o valor calculado ultrapassar o valor cadastrado,
                  o imposto  recalculado novamente para ficar valor cadastrado */
               IF (@V_VRMAXIMP > 0) BEGIN
                  IF(((@V_VRBCPERIODO + @V_VRBASECALNF) > ((@V_VRMAXIMP * 100)/@V_VRALIQUOTA))) BEGIN
                     SET @V_VRIMPOSTO = (((@V_VRMAXIMP * 100)/@V_VRALIQUOTA) * (@V_VRALIQUOTA/100)) - ISNULL(@V_IMPOSTODESC, 0) - ISNULL(@V_PARDEDTMP, 0);
                  END;
               END;
      
               IF @P_IDENTRSAIDOP = 'E' BEGIN

                  SELECT @V_VRBCALCIMPOIT = ISNULL(SUM(VRBCALCIMPOIT),0)
                    FROM TRABITPROIMPOS
                   WHERE CDFILIMPOIT  = @P_CDFILIAL
                     AND NRLANCIMPOIT = @P_NRLANCTONF
                     AND CDIMPOSTOIT  = @P_CDIMPOSTO
                     AND NRSEQITPRO   = '1';

                  SET @V_VRBCALCIMPOIT = (@V_VRBCPERIODO + @V_VRBASECALNF) - ISNULL(@V_BASECALCDESC, 0);

                  IF (@V_VRMAXIMP > 0) BEGIN
                     IF(((@V_VRBCPERIODO + @V_VRBASECALNF) > ((@V_VRMAXIMP * 100)/@V_VRALIQUOTA))) BEGIN
                        SET @V_VRBCALCIMPOIT = ROUND(((@V_VRMAXIMP * 100)/@V_VRALIQUOTA) - ISNULL(@V_BASECALCDESC, 0), 2);
                     END;
                  END;

                  IF (@V_VRIMPOSTO < 0) BEGIN
                     SET @V_VRIMPOSTO = 0;
                  END;

                  IF (@V_VRBCALCIMPOIT < 0) BEGIN
                     SET @V_VRBCALCIMPOIT = 0;
                  END;

                  UPDATE TRABIMPOSNFTOT
                     SET VRIMPOSTOT   = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                         VRBCALIMPTOT = @V_VRBCALCIMPOIT
                   WHERE CDFILIMPTOT  = @P_CDFILIAL
                     AND NRLANCIMPTOT = @P_NRLANCTONF
                     AND CDIMPOSTOT   = @P_CDIMPOSTO;
               END
               ELSE BEGIN
                  SELECT @V_VRBCALCIMPOIT = ISNULL(SUM(VRBASECALCIT),0)
                    FROM ITEMPROIMPOS
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND CDIMPOSTO    = @P_CDIMPOSTO
                     AND NRITPROIMPOS = '1';

                  SET @V_VRBCALCIMPOIT = (@V_VRBCPERIODO + @V_VRBASECALNF) - ISNULL(@V_BASECALCDESC, 0);

                  IF (@V_VRIMPOSTO < 0) BEGIN
                     SET @V_VRIMPOSTO = 0;
                  END;

                  IF (@V_VRBCALCIMPOIT < 0) BEGIN
                     SET @V_VRBCALCIMPOIT = 0;
                  END;
               END;
            END
            ELSE BEGIN
               SET @V_VRIMPOSTO = (@V_VRBASECALNF + @V_VRBCPERIODO) * (@V_VRALIQUOTA/100);

               SET @V_VRBCALCIMPOIT = 0;

               IF @P_IDENTRSAIDOP = 'E' BEGIN
                  SELECT @V_VRBCALCIMPOIT = ISNULL(SUM(VRBCALCIMPOIT),0)
                    FROM TRABITPROIMPOS
                   WHERE CDFILIMPOIT  = @P_CDFILIAL
                     AND NRLANCIMPOIT = @P_NRLANCTONF
                     AND CDIMPOSTOIT  = @P_CDIMPOSTO
                     AND NRSEQITPRO   = '1'
                     AND VRALIQIMPOIT > 0;

                  UPDATE TRABIMPOSNFTOT
                     SET VRIMPOSTOT   = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                         VRBCALIMPTOT = @V_VRBCALCIMPOIT
                   WHERE CDFILIMPTOT  = @P_CDFILIAL
                     AND NRLANCIMPTOT = @P_NRLANCTONF
                     AND CDIMPOSTOT   = @P_CDIMPOSTO;
               END
               ELSE BEGIN
                  SELECT @V_VRBCALCIMPOIT = ISNULL(SUM(VRBASECALCIT),0)
                    FROM ITEMPROIMPOS
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND CDIMPOSTO    = @P_CDIMPOSTO
                     AND NRITPROIMPOS = '1'
                     AND VRALIQITEM > 0;
               END;
            END;

            IF (@V_CALCIMPRET = 'S') BEGIN  /* Se utiliza base de clculo mensal e faixa de valores Continuar daqui*/
               DECLARE C_ITEM CURSOR FOR SELECT NRSEQITPROD, VRBCALCIRRF
                                           FROM ITEMPROIMPOS
                                          WHERE CDFILIAL   = @P_CDFILIAL
                                            AND NRLANCTONF = @P_NRLANCTONF
                                            AND CDIMPOSTO  = @P_CDIMPOSTO
                                            AND NRITPROIMPOS = '1'

               OPEN C_ITEM;
               FETCH NEXT FROM C_ITEM INTO @V_ITEM_NRSEQITPROD, @V_ITEM_VRBCALCIRRF;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_FATOCONV = 0;
                  SET @V_FATOCONV = (@V_ITEM_VRBCALCIRRF / @V_VRBASECALNF);

                  IF @P_IDENTRSAIDOP = 'E' BEGIN

                     UPDATE TRABITPROIMPOS
                        SET VRIMPOSIT     = ROUND(((@V_VRIMPOSTO * (@V_VRBCPERIODO + @V_VRBASECALNF))/ (@V_VRBCPERIODO + @V_VRBASECALNF)) * @V_FATOCONV, @V_NRDECITOTANF),
                            VRALIQIMPOIT  = @V_VRALIQUOTA,
                            VRBCALCIMPOIT = ROUND((@V_VRBCALCIMPOIT * @V_FATOCONV), 2),
                            VRPDEDIMPOIT  = ROUND((@V_PARDEDTMP * @V_FATOCONV), 2)
                      WHERE CDFILIMPOIT   = @P_CDFILIAL
                        AND NRLANCIMPOIT  = @P_NRLANCTONF
                        AND NRSEQIMPOIT   = @V_ITEM_NRSEQITPROD
                        AND CDIMPOSTOIT   = @P_CDIMPOSTO
                        AND NRSEQITPRO    = '1';

                    /* UPDATE TRABITPROIMPOS
                        SET VRIMPOSIT = ROUND(((@V_VRIMPOSTO * VRBCALCIMPOIT)/ @V_VRBCALCIMPOIT), @V_NRDECITOTANF)
                      WHERE CDFILIMPOIT  = @P_CDFILIAL
                        AND NRLANCIMPOIT = @P_NRLANCTONF
                        AND NRSEQIMPOIT  = @V_ITEM_NRSEQITPROD
                        AND CDIMPOSTOIT  = @P_CDIMPOSTO
                        AND NRSEQITPRO   = '1'; */
                  END;

                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = ROUND((@V_VRBCALCIMPOIT * @V_FATOCONV), 2),
                         VRIMPOSTOIT  = ROUND(((@V_VRIMPOSTO * (@V_VRBCPERIODO + @V_VRBASECALNF))/ (@V_VRBCPERIODO + @V_VRBASECALNF)) * @V_FATOCONV, @V_NRDECITOTANF),
                         VRALIQITEM   = @V_VRALIQUOTA,
                         VRPARDEDIT   = ROUND((@V_PARDEDTMP * @V_FATOCONV), 2)
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND NRSEQITPROD  = @V_ITEM_NRSEQITPROD
                     AND CDIMPOSTO    = @P_CDIMPOSTO
                     AND NRITPROIMPOS = '1';

                  /* UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOIT  = ROUND(((@V_VRIMPOSTO * VRBASECALCIT)/ @V_VRBCALCIMPOIT),@V_NRDECITOTANF)
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND NRSEQITPROD  = @V_ITEM_NRSEQITPROD
                     AND CDIMPOSTO    = @P_CDIMPOSTO
                     AND NRITPROIMPOS = '1'; */

                  FETCH NEXT FROM C_ITEM INTO @V_ITEM_NRSEQITPROD, @V_ITEM_VRBCALCIRRF;
               END;
               CLOSE C_ITEM;
               DEALLOCATE C_ITEM;

               --AQUI

               UPDATE IMPOSTONF
                  SET VRIMPOSTONF  = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                      VRBASECALCNF = @V_VRBCALCIMPOIT,
                      VRPARDEDNF   = @V_PARDEDTMP,
                      VRALIQNF     = @V_VRALIQUOTA
                WHERE CDFILIAL     = @P_CDFILIAL
                  AND NRLANCTONF   = @P_NRLANCTONF
                  AND CDIMPOSTO    = @P_CDIMPOSTO
                  AND IDIMPOSTONF  = '1';

               UPDATE IMPOSNFTOT
                  SET VRTOTIMPONF  = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                      VRTOTBCALCNF = @V_VRBCALCIMPOIT
                WHERE CDFILIAL     = @P_CDFILIAL
                  AND NRLANCTONF   = @P_NRLANCTONF
                  AND CDIMPOSTO    = @P_CDIMPOSTO;

               UPDATE TRABIMPOSNFTOT
                  SET VRIMPOSTOT   = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                      VRBCALIMPTOT = @V_VRBCALCIMPOIT
                WHERE CDFILIMPTOT  = @P_CDFILIAL
                  AND NRLANCIMPTOT = @P_NRLANCTONF
                  AND CDIMPOSTOT   = @P_CDIMPOSTO;


             /*  UPDATE IMPOSTONF
                  SET VRIMPOSTONF = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF)
                WHERE CDFILIAL    = @P_CDFILIAL
                  AND NRLANCTONF  = @P_NRLANCTONF
                  AND CDIMPOSTO   = @P_CDIMPOSTO
                  AND IDIMPOSTONF = '1'
                  AND VRALIQNF > 0;

               UPDATE IMPOSNFTOT
                  SET VRTOTIMPONF  = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                      VRTOTBCALCNF = @V_VRBCALCIMPOIT
                WHERE CDFILIAL     = @P_CDFILIAL
                  AND NRLANCTONF   = @P_NRLANCTONF
                  AND CDIMPOSTO    = @P_CDIMPOSTO;          */

               --Atualiza valor da impostonf de acordo com a soma dos impostof na itemproimpos

               SET @V_VRDIFERENCA = 0;
               SET @V_VRTOTIMPONF = 0;
               SET @V_VRIMPOSTOIT = 0;

               SELECT @V_VRIMPOSTOIT = ISNULL(SUM(VRIMPOSTOIT),0)
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL     = @P_CDFILIAL
                  AND NRLANCTONF   = @P_NRLANCTONF
                  AND CDIMPOSTO    = @P_CDIMPOSTO
                  AND NRITPROIMPOS = '1';

               SELECT @V_VRTOTIMPONF = ISNULL(SUM(VRIMPOSTONF),0)
                 FROM IMPOSTONF
                WHERE CDFILIAL    = @P_CDFILIAL
                  AND NRLANCTONF  = @P_NRLANCTONF
                  AND CDIMPOSTO   = @P_CDIMPOSTO
                  AND IDIMPOSTONF = '1';

               IF (@V_VRIMPOSTOIT > 0) BEGIN

                  SET @V_VRDIFERENCA = @V_VRTOTIMPONF - @V_VRIMPOSTOIT;

                  IF @V_VRDIFERENCA <> 0 BEGIN

                     IF @P_IDENTRSAIDOP = 'E' BEGIN
                        UPDATE TRABIMPOSNFTOT
                           SET VRIMPOSTOT   = VRIMPOSTOT + @V_VRDIFERENCA
                         WHERE CDFILIMPTOT  = @P_CDFILIAL
                           AND NRLANCIMPTOT = @P_NRLANCTONF
                           AND CDIMPOSTOT   = @P_CDIMPOSTO;
                     END;

                     UPDATE IMPOSTONF
                        SET VRIMPOSTONF = VRIMPOSTONF + @V_VRDIFERENCA
                      WHERE CDFILIAL    = @P_CDFILIAL
                        AND NRLANCTONF  = @P_NRLANCTONF
                        AND CDIMPOSTO   = @P_CDIMPOSTO
                        AND IDIMPOSTONF = '1'
                        AND VRALIQNF > 0;

                     UPDATE IMPOSNFTOT
                        SET VRTOTIMPONF = VRTOTIMPONF + @V_VRDIFERENCA
                      WHERE CDFILIAL    = @P_CDFILIAL
                        AND NRLANCTONF  = @P_NRLANCTONF
                        AND CDIMPOSTO   = @P_CDIMPOSTO;
                  END;
               END;
            END
            ELSE BEGIN
               DECLARE C_ITEM CURSOR FOR SELECT NRSEQITPROD
                                           FROM ITEMPROIMPOS
                                          WHERE CDFILIAL   = @P_CDFILIAL
                                            AND NRLANCTONF = @P_NRLANCTONF
                                            AND CDIMPOSTO  = @P_CDIMPOSTO
                                            AND NRITPROIMPOS = '1'
                                            AND VRALIQITEM > 0

               OPEN C_ITEM;
               FETCH NEXT FROM C_ITEM INTO @V_ITEM_NRSEQITPROD;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF @P_IDENTRSAIDOP = 'E' BEGIN
                     UPDATE TRABITPROIMPOS
                        SET VRIMPOSIT = ROUND(((@V_VRIMPOSTO * VRBCALCIMPOIT)/ @V_VRBCALCIMPOIT), @V_NRDECITOTANF)
                      WHERE CDFILIMPOIT  = @P_CDFILIAL
                        AND NRLANCIMPOIT = @P_NRLANCTONF
                        AND NRSEQIMPOIT  = @V_ITEM_NRSEQITPROD
                        AND CDIMPOSTOIT  = @P_CDIMPOSTO
                        AND NRSEQITPRO   = '1';
                  END;

                  UPDATE ITEMPROIMPOS
                     SET VRIMPOSTOIT  = ROUND(((@V_VRIMPOSTO * VRBASECALCIT)/ @V_VRBCALCIMPOIT),@V_NRDECITOTANF)
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND NRSEQITPROD  = @V_ITEM_NRSEQITPROD
                     AND CDIMPOSTO    = @P_CDIMPOSTO
                     AND NRITPROIMPOS = '1';

                  FETCH NEXT FROM C_ITEM INTO @V_ITEM_NRSEQITPROD;
               END;
               CLOSE C_ITEM;
               DEALLOCATE C_ITEM;

               UPDATE IMPOSTONF
                  SET VRIMPOSTONF = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF)
                WHERE CDFILIAL    = @P_CDFILIAL
                  AND NRLANCTONF  = @P_NRLANCTONF
                  AND CDIMPOSTO   = @P_CDIMPOSTO
                  AND IDIMPOSTONF = '1'
                  AND VRALIQNF > 0;

               UPDATE IMPOSNFTOT
                  SET VRTOTIMPONF  = ROUND(@V_VRIMPOSTO, @V_NRDECITOTANF),
                      VRTOTBCALCNF = @V_VRBCALCIMPOIT
                WHERE CDFILIAL     = @P_CDFILIAL
                  AND NRLANCTONF   = @P_NRLANCTONF
                  AND CDIMPOSTO    = @P_CDIMPOSTO;  

               --Atualiza valor da impostonf de acordo com a soma dos impostof na itemproimpos

               SET @V_VRDIFERENCA = 0;
               SET @V_VRTOTIMPONF = 0;
               SET @V_VRIMPOSTOIT = 0;

               SELECT @V_VRIMPOSTOIT = ISNULL(SUM(VRIMPOSTOIT),0)
                 FROM ITEMPROIMPOS
                WHERE CDFILIAL     = @P_CDFILIAL
                  AND NRLANCTONF   = @P_NRLANCTONF
                  AND CDIMPOSTO    = @P_CDIMPOSTO
                  AND NRITPROIMPOS = '1'
                  AND VRALIQITEM > 0;

               SELECT @V_VRTOTIMPONF = ISNULL(SUM(VRIMPOSTONF),0)
                 FROM IMPOSTONF
                WHERE CDFILIAL    = @P_CDFILIAL
                  AND NRLANCTONF  = @P_NRLANCTONF
                  AND CDIMPOSTO   = @P_CDIMPOSTO
                  AND IDIMPOSTONF = '1'
                  AND VRALIQNF > 0;

               IF (@V_VRIMPOSTOIT > 0) BEGIN

                  SET @V_VRDIFERENCA = @V_VRTOTIMPONF - @V_VRIMPOSTOIT;

                  IF @V_VRDIFERENCA <> 0 BEGIN

                     IF @P_IDENTRSAIDOP = 'E' BEGIN
                        UPDATE TRABIMPOSNFTOT
                           SET VRIMPOSTOT   = VRIMPOSTOT + @V_VRDIFERENCA
                         WHERE CDFILIMPTOT  = @P_CDFILIAL
                           AND NRLANCIMPTOT = @P_NRLANCTONF
                           AND CDIMPOSTOT   = @P_CDIMPOSTO;
                     END;

                     UPDATE IMPOSTONF
                        SET VRIMPOSTONF = VRIMPOSTONF + @V_VRDIFERENCA
                      WHERE CDFILIAL    = @P_CDFILIAL
                        AND NRLANCTONF  = @P_NRLANCTONF
                        AND CDIMPOSTO   = @P_CDIMPOSTO
                        AND IDIMPOSTONF = '1'
                        AND VRALIQNF > 0;

                     UPDATE IMPOSNFTOT
                        SET VRTOTIMPONF = VRTOTIMPONF + @V_VRDIFERENCA
                      WHERE CDFILIAL    = @P_CDFILIAL
                        AND NRLANCTONF  = @P_NRLANCTONF
                        AND CDIMPOSTO   = @P_CDIMPOSTO;
                  END;
               END;
            END;
            SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
              FROM NOTABCMENSAL
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANCTONF = @P_NRLANCTONF
               AND CDIMPOSTO = @P_CDIMPOSTO
               AND NOT EXISTS (SELECT N.CDFILIAL
                                 FROM NOTABCMENSAL N
                                WHERE N.CDFILIALIT = @P_CDFILIAL
                                  AND N.NRLANCTONFIT = @P_NRLANCTONF
                                  AND CDIMPOSTO = @P_CDIMPOSTO);

             IF (@V_NRSEQAUX <> 0) BEGIN
                SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
                  FROM NOTABCMENSAL
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCTONF = @P_NRLANCTONF
                   AND NOT EXISTS (SELECT N.CDFILIAL
                                     FROM NOTABCMENSAL N
                                    WHERE N.CDFILIALIT = @P_CDFILIAL
                                      AND N.NRLANCTONFIT = @P_NRLANCTONF);

                INSERT INTO NOTABCMENSAL
                   (CDFILIAL, NRLANCTONF, NRSEQUNOTAIT, CDFILIALIT, NRLANCTONFIT, IDNFBCMENSALCALC, CDIMPOSTO)
                VALUES
                   (@P_CDFILIAL, @P_NRLANCTONF, RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQAUX) + 1)),4), @P_CDFILIAL, @P_NRLANCTONF, 'S', @P_CDIMPOSTO);
             END;
         END
         ELSE BEGIN
            IF @P_IDENTRSAIDOP = 'E' BEGIN
               UPDATE TRABIMPOSNFTOT
               SET VRIMPOSTOT = 0.00
               WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
                     NRLANCIMPTOT = @P_NRLANCTONF  AND
                     CDIMPOSTOT   = @P_CDIMPOSTO;

               UPDATE TRABITPROIMPOS
               SET VRIMPOSIT    = 0.00,
                   VRALIQIMPOIT = 0.00
               WHERE CDFILIMPOIT  = @P_CDFILIAL    AND
                     NRLANCIMPOIT = @P_NRLANCTONF  AND
                     CDIMPOSTOIT  = @P_CDIMPOSTO;
            END;

            UPDATE ITEMPROIMPOS
            SET VRALIQITEM  = 0.00,
                VRIMPOSTOIT = 0.00
            WHERE CDFILIAL   = @P_CDFILIAL    AND
                  NRLANCTONF = @P_NRLANCTONF  AND
                  CDIMPOSTO  = @P_CDIMPOSTO;

            UPDATE IMPOSTONF
            SET VRIMPOSTONF = 0.00
            WHERE CDFILIAL   = @P_CDFILIAL    AND
                  NRLANCTONF = @P_NRLANCTONF  AND
                  CDIMPOSTO  = @P_CDIMPOSTO;

            UPDATE IMPOSNFTOT
            SET VRTOTIMPONF = 0.00
            WHERE CDFILIAL   = @P_CDFILIAL    AND
                  NRLANCTONF = @P_NRLANCTONF  AND
                  CDIMPOSTO  = @P_CDIMPOSTO;
         END;
         IF (@V_IDFORMAPUR = 'P') BEGIN
            IF @P_IDENTRSAIDOP = 'E' BEGIN
               IF (@V_CALCIMPRET = 'S') BEGIN
                  DECLARE C_NOTABCMENSAL CURSOR FOR     SELECT NF.CDFILIAL, NF.NRLANCTONF
                                                          FROM NOTAFISCAL NF, ITEMPROIMPOS IP
                                                         WHERE NF.CDEMPRESA    = @P_CDEMPRESA
                                                           AND NF.IDTPIJURNF   = @P_IDTPIJURNF
                                                           AND ((NF.IDTPIJURNF = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                                                            OR NF.NRINSJURNF   = @P_NRINSJURNF)
                                                           AND NF.IDENTRSAIDOP = @P_IDENTRSAIDOP
                                                           AND NF.CDFILIAL     = IP.CDFILIAL
                                                           AND NF.NRLANCTONF   = IP.NRLANCTONF
                                                           AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                                                           AND NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF
                                                           AND IP.VRBCALCIRRF > 0
                                                           AND EXISTS (SELECT C.CDFILIAL
                                                                         FROM CONTAPAGAR C
                                                                        WHERE C.CDFILIAL = NF.CDFILIAL
                                                                          AND C.NRLANCTONF = NF.NRLANCTONF
                                                                          AND DTORIGVENPAG BETWEEN @V_DTATUAPAG AND @V_DTULTMES)
                                                           AND NOT EXISTS (SELECT N.CDFILIAL
                                                                     FROM NOTABCMENSAL N
                                                                    WHERE N.CDFILIALIT = @P_CDFILIAL
                                                                      AND N.NRLANCTONFIT = @P_NRLANCTONF
                                                                      AND CDIMPOSTO = @P_CDIMPOSTO);
                  OPEN C_NOTABCMENSAL;
                  FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     SELECT @V_NRSEQUNOTAIT = MAX(NRSEQUNOTAIT)
                       FROM NOTABCMENSAL
                      WHERE CDFILIAL     = @P_CDFILIAL
                        AND NRLANCTONF   = @P_NRLANCTONF
                        AND CDFILIALIT   = @V_NOTABCMENSAL_CDFILIAL
                        AND NRLANCTONFIT = @V_NOTABCMENSAL_NRLANCTONF;

                     IF (@V_NRSEQUNOTAIT IS NULL) BEGIN
                        SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
                          FROM NOTABCMENSAL
                         WHERE CDFILIAL   = @P_CDFILIAL
                           AND NRLANCTONF = @P_NRLANCTONF;

                        INSERT INTO NOTABCMENSAL
                           (CDFILIAL, NRLANCTONF, NRSEQUNOTAIT, CDFILIALIT, NRLANCTONFIT, IDNFBCMENSALCALC, CDIMPOSTO)
                        VALUES
                           (@P_CDFILIAL, @P_NRLANCTONF, RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQAUX) + 1)),4), @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF, 'N', @P_CDIMPOSTO);
                     END;
                     FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;
                  END;
                  CLOSE C_NOTABCMENSAL;
                  DEALLOCATE C_NOTABCMENSAL;
               END
               ELSE BEGIN
                  DECLARE C_NOTABCMENSAL CURSOR FOR     SELECT NF.CDFILIAL, NF.NRLANCTONF
                                                          FROM NOTAFISCAL NF, IMPOSTONF IP
                                                         WHERE NF.CDEMPRESA    = @P_CDEMPRESA
                                                           AND NF.IDTPIJURNF   = @P_IDTPIJURNF
                                                           AND ((NF.IDTPIJURNF = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                                                            OR NF.NRINSJURNF   = @P_NRINSJURNF)
                                                           AND NF.IDENTRSAIDOP = @P_IDENTRSAIDOP
                                                           AND NF.CDFILIAL     = IP.CDFILIAL
                                                           AND NF.NRLANCTONF   = IP.NRLANCTONF
                                                           AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                                                           AND NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF
                                                           AND IP.VRBASECALCNF > 0
                                                           AND EXISTS (SELECT C.CDFILIAL
                                                                         FROM CONTAPAGAR C
                                                                        WHERE C.CDFILIAL = NF.CDFILIAL
                                                                          AND C.NRLANCTONF = NF.NRLANCTONF
                                                                          AND DTORIGVENPAG BETWEEN @V_DTATUAPAG AND @V_DTULTMES)
                                                           AND NOT EXISTS (SELECT N.CDFILIAL
                                                                     FROM NOTABCMENSAL N
                                                                    WHERE N.CDFILIALIT = @P_CDFILIAL
                                                                      AND N.NRLANCTONFIT = @P_NRLANCTONF
                                                                      AND CDIMPOSTO = @P_CDIMPOSTO);
                  OPEN C_NOTABCMENSAL;
                  FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     SELECT @V_NRSEQUNOTAIT = MAX(NRSEQUNOTAIT)
                       FROM NOTABCMENSAL
                      WHERE CDFILIAL     = @P_CDFILIAL
                        AND NRLANCTONF   = @P_NRLANCTONF
                        AND CDFILIALIT   = @V_NOTABCMENSAL_CDFILIAL
                        AND NRLANCTONFIT = @V_NOTABCMENSAL_NRLANCTONF;

                     IF (@V_NRSEQUNOTAIT IS NULL) BEGIN
                        SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
                          FROM NOTABCMENSAL
                         WHERE CDFILIAL   = @P_CDFILIAL
                           AND NRLANCTONF = @P_NRLANCTONF;

                        INSERT INTO NOTABCMENSAL
                           (CDFILIAL, NRLANCTONF, NRSEQUNOTAIT, CDFILIALIT, NRLANCTONFIT, IDNFBCMENSALCALC, CDIMPOSTO)
                        VALUES
                           (@P_CDFILIAL, @P_NRLANCTONF, RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQAUX) + 1)),4), @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF, 'N', @P_CDIMPOSTO);
                     END;
                     FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;
                  END;
                  CLOSE C_NOTABCMENSAL;
                  DEALLOCATE C_NOTABCMENSAL;
               END;
            END
            ELSE BEGIN
               DECLARE C_NOTABCMENSAL CURSOR FOR     SELECT NF.CDFILIAL, NF.NRLANCTONF
                                                       FROM NOTAFISCAL NF, IMPOSTONF IP
                                                      WHERE NF.CDEMPRESA    = @P_CDEMPRESA
                                                        AND NF.IDTPIJURNF   = @P_IDTPIJURNF
                                                        AND ((NF.IDTPIJURNF = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                                                         OR NF.NRINSJURNF   = @P_NRINSJURNF)
                                                        AND NF.IDENTRSAIDOP = @P_IDENTRSAIDOP
                                                        AND NF.CDFILIAL     = IP.CDFILIAL
                                                        AND NF.NRLANCTONF   = IP.NRLANCTONF
                                                        AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                                                        AND NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF
                                                        AND IP.VRBASECALCNF > 0
                                                        AND EXISTS (SELECT C.CDFILIAL
                                                                      FROM CONTARECEBER C
                                                                     WHERE C.CDFILIAL = NF.CDFILIAL
                                                                       AND C.NRLANCTONF = NF.NRLANCTONF
                                                                       AND DTATUAVENREC BETWEEN @V_DTATUAPAG AND @V_DTULTMES)
                                                        AND NOT EXISTS (SELECT N.CDFILIAL
                                                                  FROM NOTABCMENSAL N
                                                                 WHERE N.CDFILIALIT = @P_CDFILIAL
                                                                   AND N.NRLANCTONFIT = @P_NRLANCTONF
                                                                   AND CDIMPOSTO = @P_CDIMPOSTO);
               OPEN C_NOTABCMENSAL;
               FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_NRSEQUNOTAIT = MAX(NRSEQUNOTAIT)
                    FROM NOTABCMENSAL
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND CDFILIALIT   = @V_NOTABCMENSAL_CDFILIAL
                     AND NRLANCTONFIT = @V_NOTABCMENSAL_NRLANCTONF;

                  IF (@V_NRSEQUNOTAIT IS NULL) BEGIN
                     SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
                       FROM NOTABCMENSAL
                      WHERE CDFILIAL   = @P_CDFILIAL
                        AND NRLANCTONF = @P_NRLANCTONF;

                     INSERT INTO NOTABCMENSAL
                        (CDFILIAL, NRLANCTONF, NRSEQUNOTAIT, CDFILIALIT, NRLANCTONFIT, IDNFBCMENSALCALC, CDIMPOSTO)
                     VALUES
                        (@P_CDFILIAL, @P_NRLANCTONF, RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQAUX) + 1)),4), @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF, 'N', @P_CDIMPOSTO);
                  END;
                  FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;
               END;
               CLOSE C_NOTABCMENSAL;
               DEALLOCATE C_NOTABCMENSAL;
            END;
         END
         ELSE BEGIN
            IF (@V_CALCIMPRET = 'S') BEGIN
               DECLARE C_NOTABCMENSAL CURSOR FOR     SELECT NF.CDFILIAL, NF.NRLANCTONF
                                                       FROM NOTAFISCAL NF, ITEMPROIMPOS IP
                                                      WHERE NF.CDEMPRESA    = @P_CDEMPRESA
                                                        AND NF.IDTPIJURNF   = @P_IDTPIJURNF
                                                        AND ((NF.IDTPIJURNF = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                                                         OR NF.NRINSJURNF   = @P_NRINSJURNF)
                                                        AND NF.IDENTRSAIDOP = @P_IDENTRSAIDOP
                                                        AND NF.DTENTRSAID  BETWEEN @V_DATAINI AND @P_DATALANCNF
                                                        AND NF.CDFILIAL     = IP.CDFILIAL
                                                        AND NF.NRLANCTONF   = IP.NRLANCTONF
                                                        AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                                                        AND NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF
                                                        AND IP.VRBCALCIRRF > 0
                                                        AND NOT EXISTS (SELECT N.CDFILIAL
                                                                          FROM NOTABCMENSAL N
                                                                         WHERE N.CDFILIALIT = @P_CDFILIAL
                                                                           AND N.NRLANCTONFIT = @P_NRLANCTONF
                                                                           AND CDIMPOSTO = @P_CDIMPOSTO);
               OPEN C_NOTABCMENSAL;
               FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_NRSEQUNOTAIT = MAX(NRSEQUNOTAIT)
                    FROM NOTABCMENSAL
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND CDFILIALIT   = @V_NOTABCMENSAL_CDFILIAL
                     AND NRLANCTONFIT = @V_NOTABCMENSAL_NRLANCTONF;
                  IF (@V_NRSEQUNOTAIT IS NULL) BEGIN
                     SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
                       FROM NOTABCMENSAL
                      WHERE CDFILIAL   = @P_CDFILIAL
                        AND NRLANCTONF = @P_NRLANCTONF;

                     INSERT INTO NOTABCMENSAL
                        (CDFILIAL, NRLANCTONF, NRSEQUNOTAIT, CDFILIALIT, NRLANCTONFIT, IDNFBCMENSALCALC, CDIMPOSTO)
                     VALUES
                        (@P_CDFILIAL, @P_NRLANCTONF, RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQAUX) + 1)),4), @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF, 'N', @P_CDIMPOSTO);
                  END;
                  FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;
               END;
               CLOSE C_NOTABCMENSAL;
               DEALLOCATE C_NOTABCMENSAL;
            END
            ELSE BEGIN
               DECLARE C_NOTABCMENSAL CURSOR FOR     SELECT NF.CDFILIAL, NF.NRLANCTONF
                                                       FROM NOTAFISCAL NF, IMPOSTONF IP
                                                      WHERE NF.CDEMPRESA    = @P_CDEMPRESA
                                                        AND NF.IDTPIJURNF   = @P_IDTPIJURNF
                                                        AND ((NF.IDTPIJURNF = 'J' AND SUBSTRING(NF.NRINSJURNF,1,8) = SUBSTRING(@P_NRINSJURNF,1,8))
                                                         OR NF.NRINSJURNF   = @P_NRINSJURNF)
                                                        AND NF.IDENTRSAIDOP = @P_IDENTRSAIDOP
                                                        AND NF.DTENTRSAID  BETWEEN @V_DATAINI AND @P_DATALANCNF
                                                        AND NF.CDFILIAL     = IP.CDFILIAL
                                                        AND NF.NRLANCTONF   = IP.NRLANCTONF
                                                        AND IP.CDIMPOSTO    = @P_CDIMPOSTO
                                                        AND NF.CDFILIAL+NF.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF
                                                        AND IP.VRBASECALCNF > 0
                                                        AND NOT EXISTS (SELECT N.CDFILIAL
                                                                          FROM NOTABCMENSAL N
                                                                         WHERE N.CDFILIALIT = @P_CDFILIAL
                                                                           AND N.NRLANCTONFIT = @P_NRLANCTONF
                                                                           AND CDIMPOSTO = @P_CDIMPOSTO);
               OPEN C_NOTABCMENSAL;
               FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_NRSEQUNOTAIT = MAX(NRSEQUNOTAIT)
                    FROM NOTABCMENSAL
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND CDFILIALIT   = @V_NOTABCMENSAL_CDFILIAL
                     AND NRLANCTONFIT = @V_NOTABCMENSAL_NRLANCTONF;
                  IF (@V_NRSEQUNOTAIT IS NULL) BEGIN
                     SELECT @V_NRSEQAUX = ISNULL(MAX(NRSEQUNOTAIT),0)
                       FROM NOTABCMENSAL
                      WHERE CDFILIAL   = @P_CDFILIAL
                        AND NRLANCTONF = @P_NRLANCTONF;

                     INSERT INTO NOTABCMENSAL
                        (CDFILIAL, NRLANCTONF, NRSEQUNOTAIT, CDFILIALIT, NRLANCTONFIT, IDNFBCMENSALCALC, CDIMPOSTO)
                     VALUES
                        (@P_CDFILIAL, @P_NRLANCTONF, RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRSEQAUX) + 1)),4), @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF, 'N', @P_CDIMPOSTO);
                  END;
                  FETCH NEXT FROM C_NOTABCMENSAL INTO @V_NOTABCMENSAL_CDFILIAL, @V_NOTABCMENSAL_NRLANCTONF;
               END;
               CLOSE C_NOTABCMENSAL;
               DEALLOCATE C_NOTABCMENSAL;
            END;
         END;
      END;
   END
   ELSE BEGIN
      IF @P_IDENTRSAIDOP = 'E' BEGIN
        UPDATE TRABIMPOSNFTOT
        SET VRIMPOSTOT = 0.00
        WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
              NRLANCIMPTOT = @P_NRLANCTONF  AND
              CDIMPOSTOT   = @P_CDIMPOSTO;

        UPDATE TRABITPROIMPOS
        SET VRIMPOSIT    = 0.00,
            VRALIQIMPOIT = 0.00
        WHERE CDFILIMPOIT  = @P_CDFILIAL    AND
              NRLANCIMPOIT = @P_NRLANCTONF  AND
              CDIMPOSTOIT  = @P_CDIMPOSTO;

     END;

     UPDATE ITEMPROIMPOS
     SET VRALIQITEM  = 0.00,
         VRIMPOSTOIT = 0.00
     WHERE CDFILIAL   = @P_CDFILIAL    AND
           NRLANCTONF = @P_NRLANCTONF  AND
           CDIMPOSTO  = @P_CDIMPOSTO;

     UPDATE IMPOSTONF
      SET VRIMPOSTONF = 0.00
      WHERE CDFILIAL   = @P_CDFILIAL    AND
            NRLANCTONF = @P_NRLANCTONF  AND
            CDIMPOSTO  = @P_CDIMPOSTO;

      UPDATE IMPOSNFTOT
      SET VRTOTIMPONF = 0.00
      WHERE CDFILIAL   = @P_CDFILIAL    AND
            NRLANCTONF = @P_NRLANCTONF  AND
            CDIMPOSTO  = @P_CDIMPOSTO;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'BASECALC_RETIDO','6.05.XXX';
GO


